diff --git a/drivers/media/platform/raspberrypi/pisp_be/pisp_be.c b/drivers/media/platform/raspberrypi/pisp_be/pisp_be.c
index 49594e539c4f..2db4211b2b35 100644
--- a/drivers/media/platform/raspberrypi/pisp_be/pisp_be.c
+++ b/drivers/media/platform/raspberrypi/pisp_be/pisp_be.c
@@ -1522,36 +1557,43 @@ static int pispbe_init_subdev(struct pispbe_dev *pispbe)
 	return ret;
 }
 
-static int pispbe_init_devices(struct pispbe_dev *pispbe)
+static int pispbe_init_group(struct pispbe_dev *pispbe, unsigned int id)
 {
+	struct pispbe_node_group *node_group = &pispbe->node_group[id];
 	struct v4l2_device *v4l2_dev;
 	struct media_device *mdev;
 	unsigned int num_regist;
 	int ret;
 
+	node_group->id = id;
+	node_group->pispbe = pispbe;
+	node_group->streaming_map = 0;
+
+	dev_dbg(pispbe->dev, "Register nodes for group %u\n", id);
+
 	/* Register v4l2_device and media_device */
-	mdev = &pispbe->mdev;
-	mdev->hw_revision = pispbe->hw_version;
-	mdev->dev = pispbe->dev;
+	mdev = &node_group->mdev;
+	mdev->hw_revision = node_group->pispbe->hw_version;
+	mdev->dev = node_group->pispbe->dev;
 	strscpy(mdev->model, PISPBE_NAME, sizeof(mdev->model));
 	media_device_init(mdev);
 
-	v4l2_dev = &pispbe->v4l2_dev;
-	v4l2_dev->mdev = &pispbe->mdev;
+	v4l2_dev = &node_group->v4l2_dev;
+	v4l2_dev->mdev = &node_group->mdev;
 	strscpy(v4l2_dev->name, PISPBE_NAME, sizeof(v4l2_dev->name));
 
-	ret = v4l2_device_register(pispbe->dev, v4l2_dev);
+	ret = v4l2_device_register(pispbe->dev, &node_group->v4l2_dev);
 	if (ret)
 		goto err_media_dev_cleanup;
 
 	/* Register the PISPBE subdevice. */
-	ret = pispbe_init_subdev(pispbe);
+	ret = pispbe_init_subdev(node_group);
 	if (ret)
 		goto err_unregister_v4l2;
 
 	/* Create device video nodes */
 	for (num_regist = 0; num_regist < PISPBE_NUM_NODES; num_regist++) {
-		ret = pispbe_init_node(pispbe, num_regist);
+		ret = pispbe_init_node(node_group, num_regist);
 		if (ret)
 			goto err_unregister_nodes;
 	}
@@ -1560,12 +1602,12 @@ static int pispbe_init_devices(struct pispbe_dev *pispbe)
 	if (ret)
 		goto err_unregister_nodes;
 
-	pispbe->config =
+	node_group->config =
 		dma_alloc_coherent(pispbe->dev,
 				   sizeof(struct pisp_be_tiles_config) *
 					PISP_BE_NUM_CONFIG_BUFFERS,
-				   &pispbe->config_dma_addr, GFP_KERNEL);
-	if (!pispbe->config) {
+				   &node_group->config_dma_addr, GFP_KERNEL);
+	if (!node_group->config) {
 		dev_err(pispbe->dev, "Unable to allocate cached config buffers.\n");
 		ret = -ENOMEM;
 		goto err_unregister_mdev;
@@ -1577,11 +1619,11 @@ static int pispbe_init_devices(struct pispbe_dev *pispbe)
 	media_device_unregister(mdev);
 err_unregister_nodes:
 	while (num_regist-- > 0) {
-		video_unregister_device(&pispbe->node[num_regist].vfd);
-		vb2_queue_release(&pispbe->node[num_regist].queue);
+		video_unregister_device(&node_group->node[num_regist].vfd);
+		vb2_queue_release(&node_group->node[num_regist].queue);
 	}
-	v4l2_device_unregister_subdev(&pispbe->sd);
-	media_entity_cleanup(&pispbe->sd.entity);
+	v4l2_device_unregister_subdev(&node_group->sd);
+	media_entity_cleanup(&node_group->sd.entity);
 err_unregister_v4l2:
 	v4l2_device_unregister(v4l2_dev);
 err_media_dev_cleanup:
@@ -1589,31 +1631,33 @@ static int pispbe_init_devices(struct pispbe_dev *pispbe)
 	return ret;
 }
 
-static void pispbe_destroy_devices(struct pispbe_dev *pispbe)
+static void pispbe_destroy_node_group(struct pispbe_node_group *node_group)
 {
-	if (pispbe->config) {
-		dma_free_coherent(pispbe->dev,
+	struct pispbe_dev *pispbe = node_group->pispbe;
+
+	if (node_group->config) {
+		dma_free_coherent(node_group->pispbe->dev,
 				  sizeof(struct pisp_be_tiles_config) *
 					PISP_BE_NUM_CONFIG_BUFFERS,
-				  pispbe->config,
-				  pispbe->config_dma_addr);
+				  node_group->config,
+				  node_group->config_dma_addr);
 	}
 
 	dev_dbg(pispbe->dev, "Unregister from media controller\n");
 
-	v4l2_device_unregister_subdev(&pispbe->sd);
-	media_entity_cleanup(&pispbe->sd.entity);
-	media_device_unregister(&pispbe->mdev);
+	v4l2_device_unregister_subdev(&node_group->sd);
+	media_entity_cleanup(&node_group->sd.entity);
+	media_device_unregister(&node_group->mdev);
 
 	for (int i = PISPBE_NUM_NODES - 1; i >= 0; i--) {
-		video_unregister_device(&pispbe->node[i].vfd);
-		vb2_queue_release(&pispbe->node[i].queue);
-		mutex_destroy(&pispbe->node[i].node_lock);
-		mutex_destroy(&pispbe->node[i].queue_lock);
+		video_unregister_device(&node_group->node[i].vfd);
+		vb2_queue_release(&node_group->node[i].queue);
+		mutex_destroy(&node_group->node[i].node_lock);
+		mutex_destroy(&node_group->node[i].queue_lock);
 	}
 
-	media_device_cleanup(&pispbe->mdev);
-	v4l2_device_unregister(&pispbe->v4l2_dev);
+	media_device_cleanup(&node_group->mdev);
+	v4l2_device_unregister(&node_group->v4l2_dev);
 }
 
 static int pispbe_runtime_suspend(struct device *dev)
@@ -1681,9 +1725,13 @@ static int pispbe_hw_init(struct pispbe_dev *pispbe)
 	return 0;
 }
 
-/* Probe the ISP-BE hardware block, as a single platform device. */
+/*
+ * Probe the ISP-BE hardware block, as a single platform device.
+ * This will instantiate multiple "node groups" each with many device nodes.
+ */
 static int pispbe_probe(struct platform_device *pdev)
 {
+	unsigned int num_groups = 0;
 	struct pispbe_dev *pispbe;
 	int ret;
 
@@ -1691,6 +1739,8 @@ static int pispbe_probe(struct platform_device *pdev)
 	if (!pispbe)
 		return -ENOMEM;
 
+	INIT_LIST_HEAD(&pispbe->job_queue);
+
 	dev_set_drvdata(&pdev->dev, pispbe);
 	pispbe->dev = &pdev->dev;
 	platform_set_drvdata(pdev, pispbe);
@@ -1736,17 +1786,26 @@ static int pispbe_probe(struct platform_device *pdev)
 	if (ret)
 		goto pm_runtime_suspend_err;
 
-	ret = pispbe_init_devices(pispbe);
-	if (ret)
-		goto disable_devs_err;
+	/*
+	 * Initialise and register devices for each node_group, including media
+	 * device
+	 */
+	for (num_groups = 0;
+	     num_groups < PISPBE_NUM_NODE_GROUPS;
+	     num_groups++) {
+		ret = pispbe_init_group(pispbe, num_groups);
+		if (ret)
+			goto disable_nodes_err;
+	}
 
 	pm_runtime_mark_last_busy(pispbe->dev);
 	pm_runtime_put_autosuspend(pispbe->dev);
 
 	return 0;
 
-disable_devs_err:
-	pispbe_destroy_devices(pispbe);
+disable_nodes_err:
+	while (num_groups-- > 0)
+		pispbe_destroy_node_group(&pispbe->node_group[num_groups]);
 pm_runtime_suspend_err:
 	pm_runtime_put(pispbe->dev);
 pm_runtime_disable_err:
@@ -1760,7 +1819,8 @@ static void pispbe_remove(struct platform_device *pdev)
 {
 	struct pispbe_dev *pispbe = platform_get_drvdata(pdev);
 
-	pispbe_destroy_devices(pispbe);
+	for (int i = PISPBE_NUM_NODE_GROUPS - 1; i >= 0; i--)
+		pispbe_destroy_node_group(&pispbe->node_group[i]);
 
 	pm_runtime_dont_use_autosuspend(pispbe->dev);
 	pm_runtime_disable(pispbe->dev);
diff --git a/drivers/media/platform/raspberrypi/pisp_be/pisp_be_formats.h b/drivers/media/platform/raspberrypi/pisp_be/pisp_be_formats.h
index b5cb7b8c7531..1b0386c49281 100644
--- a/drivers/media/platform/raspberrypi/pisp_be/pisp_be_formats.h
+++ b/drivers/media/platform/raspberrypi/pisp_be/pisp_be_formats.h
@@ -16,7 +16,8 @@
 
 struct pisp_be_format {
 	unsigned int fourcc;
-	unsigned int align;
+	unsigned int opt_align;
+	unsigned int min_align;
 	unsigned int bit_depth;
 	/* 0P3 factor for plane sizing */
 	unsigned int plane_factor[PISPBE_MAX_PLANES];
@@ -58,7 +59,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_YUV420,
 		/* 128 alignment to ensure U/V planes are 64 byte aligned. */
-		.align		    = 128,
+		.opt_align	    = 128,
+		.min_align	    = 32,
 		.bit_depth	    = 8,
 		.plane_factor	    = { P3(1), P3(0.25), P3(0.25) },
 		.num_planes	    = 1,
@@ -68,7 +70,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_YVU420,
 		/* 128 alignment to ensure U/V planes are 64 byte aligned. */
-		.align		    = 128,
+		.opt_align	    = 128,
+		.min_align	    = 32,
 		.bit_depth	    = 8,
 		.plane_factor	    = { P3(1), P3(0.25), P3(0.25) },
 		.num_planes	    = 1,
@@ -77,7 +80,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_NV12,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.bit_depth	    = 8,
 		.plane_factor	    = { P3(1), P3(0.5) },
 		.num_planes	    = 1,
@@ -86,7 +90,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_NV21,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.bit_depth	    = 8,
 		.plane_factor	    = { P3(1), P3(0.5) },
 		.num_planes	    = 1,
@@ -95,7 +100,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_YUYV,
-		.align		    = 64,
+		.opt_align	    = 64,
+		.min_align	    = 16,
 		.bit_depth	    = 16,
 		.plane_factor	    = { P3(1) },
 		.num_planes	    = 1,
@@ -104,7 +110,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_UYVY,
-		.align		    = 64,
+		.opt_align	    = 64,
+		.min_align	    = 16,
 		.bit_depth	    = 16,
 		.plane_factor	    = { P3(1) },
 		.num_planes	    = 1,
@@ -113,7 +120,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_YVYU,
-		.align		    = 64,
+		.opt_align	    = 64,
+		.min_align	    = 16,
 		.bit_depth	    = 16,
 		.plane_factor	    = { P3(1) },
 		.num_planes	    = 1,
@@ -122,17 +130,30 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_VYUY,
-		.align		    = 64,
+		.opt_align	    = 64,
+		.min_align	    = 16,
 		.bit_depth	    = 16,
 		.plane_factor	    = { P3(1) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_ALL_SRGB,
 		.colorspace_default = V4L2_COLORSPACE_SMPTE170M,
 	},
+	{
+		.fourcc		    = V4L2_PIX_FMT_YUV422P,
+		/* 128 alignment to ensure U/V planes are 64 byte aligned. */
+		.opt_align	    = 128,
+		.min_align	    = 32,
+		.bit_depth	    = 8,
+		.plane_factor	    = { P3(1), P3(0.5), P3(0.5) },
+		.num_planes	    = 1,
+		.colorspace_mask    = V4L2_COLORSPACE_MASK_ALL_SRGB,
+		.colorspace_default = V4L2_COLORSPACE_SMPTE170M,
+	},
 	/* Multiplane YUV formats */
 	{
 		.fourcc		    = V4L2_PIX_FMT_YUV420M,
-		.align		    = 64,
+		.opt_align	    = 64,
+		.min_align	    = 16,
 		.bit_depth	    = 8,
 		.plane_factor	    = { P3(1), P3(0.25), P3(0.25) },
 		.num_planes	    = 3,
@@ -141,7 +162,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_NV12M,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.bit_depth	    = 8,
 		.plane_factor	    = { P3(1), P3(0.5) },
 		.num_planes	    = 2,
@@ -150,7 +172,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_NV21M,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.bit_depth	    = 8,
 		.plane_factor	    = { P3(1), P3(0.5) },
 		.num_planes	    = 2,
@@ -159,7 +182,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_YVU420M,
-		.align		    = 64,
+		.opt_align	    = 64,
+		.min_align	    = 16,
 		.bit_depth	    = 8,
 		.plane_factor	    = { P3(1), P3(0.25), P3(0.25) },
 		.num_planes	    = 3,
@@ -168,7 +192,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_YUV422M,
-		.align		    = 64,
+		.opt_align	    = 64,
+		.min_align	    = 16,
 		.bit_depth	    = 8,
 		.plane_factor	    = { P3(1), P3(0.5), P3(0.5) },
 		.num_planes	    = 3,
@@ -177,7 +202,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_YVU422M,
-		.align		    = 64,
+		.opt_align	    = 64,
+		.min_align	    = 16,
 		.bit_depth	    = 8,
 		.plane_factor	    = { P3(1), P3(0.5), P3(0.5) },
 		.num_planes	    = 3,
@@ -186,7 +212,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_YUV444M,
-		.align		    = 64,
+		.opt_align	    = 64,
+		.min_align	    = 16,
 		.bit_depth	    = 8,
 		.plane_factor	    = { P3(1), P3(1), P3(1) },
 		.num_planes	    = 3,
@@ -195,7 +222,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_YVU444M,
-		.align		    = 64,
+		.opt_align	    = 64,
+		.min_align	    = 16,
 		.bit_depth	    = 8,
 		.plane_factor	    = { P3(1), P3(1), P3(1) },
 		.num_planes	    = 3,
@@ -205,7 +233,8 @@ static const struct pisp_be_format supported_formats[] = {
 	/* RGB formats */
 	{
 		.fourcc		    = V4L2_PIX_FMT_RGB24,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.bit_depth	    = 24,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
@@ -214,7 +243,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_BGR24,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.bit_depth	    = 24,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
@@ -223,7 +253,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_XBGR32,
-		.align		    = 64,
+		.opt_align	    = 64,
+		.min_align	    = 16,
 		.bit_depth	    = 32,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
@@ -232,7 +263,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_RGBX32,
-		.align		    = 64,
+		.opt_align	    = 64,
+		.min_align	    = 16,
 		.bit_depth	    = 32,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
@@ -241,7 +273,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_RGB48,
-		.align		    = 64,
+		.opt_align	    = 64,
+		.min_align	    = 16,
 		.bit_depth	    = 48,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
@@ -250,7 +283,8 @@ static const struct pisp_be_format supported_formats[] = {
 	},
 	{
 		.fourcc		    = V4L2_PIX_FMT_BGR48,
-		.align		    = 64,
+		.opt_align	    = 64,
+		.min_align	    = 16,
 		.bit_depth	    = 48,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
@@ -261,7 +295,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SRGGB8,
 		.bit_depth	    = 8,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -270,7 +305,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SBGGR8,
 		.bit_depth	    = 8,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -279,7 +315,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SGRBG8,
 		.bit_depth	    = 8,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -288,7 +325,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SGBRG8,
 		.bit_depth	    = 8,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -298,7 +336,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SRGGB16,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -307,7 +346,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SBGGR16,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -316,7 +356,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SGRBG16,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -325,7 +366,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SGBRG16,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -336,7 +378,8 @@ static const struct pisp_be_format supported_formats[] = {
 		/* 10 bit */
 		.fourcc		    = V4L2_PIX_FMT_SRGGB10,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -345,7 +388,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SBGGR10,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -354,7 +398,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SGRBG10,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -363,7 +408,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SGBRG10,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -373,7 +419,8 @@ static const struct pisp_be_format supported_formats[] = {
 		/* 12 bit */
 		.fourcc		    = V4L2_PIX_FMT_SRGGB12,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -382,7 +429,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SBGGR12,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -391,7 +439,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SGRBG12,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -400,7 +449,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SGBRG12,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -410,7 +460,8 @@ static const struct pisp_be_format supported_formats[] = {
 		/* 14 bit */
 		.fourcc		    = V4L2_PIX_FMT_SRGGB14,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -419,7 +470,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SBGGR14,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -428,7 +480,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SGRBG14,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -437,7 +490,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_SGBRG14,
 		.bit_depth	    = 16,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -447,7 +501,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_PISP_COMP1_BGGR,
 		.bit_depth	    = 8,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -456,7 +511,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_PISP_COMP1_RGGB,
 		.bit_depth	    = 8,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -465,7 +521,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_PISP_COMP1_GRBG,
 		.bit_depth	    = 8,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -474,7 +531,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		    = V4L2_PIX_FMT_PISP_COMP1_GBRG,
 		.bit_depth	    = 8,
-		.align		    = 32,
+		.opt_align	    = 32,
+		.min_align	    = 16,
 		.plane_factor	    = { P3(1.0) },
 		.num_planes	    = 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -484,7 +542,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		= V4L2_PIX_FMT_GREY,
 		.bit_depth	= 8,
-		.align		= 32,
+		.opt_align	= 32,
+		.min_align	= 16,
 		.num_planes	= 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
 		.colorspace_default = V4L2_COLORSPACE_RAW,
@@ -492,7 +551,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		= V4L2_PIX_FMT_Y16,
 		.bit_depth	= 16,
-		.align		= 32,
+		.opt_align	= 32,
+		.min_align	= 16,
 		.plane_factor	= { P3(1.0) },
 		.num_planes	= 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
@@ -501,7 +561,8 @@ static const struct pisp_be_format supported_formats[] = {
 	{
 		.fourcc		= V4L2_PIX_FMT_PISP_COMP1_MONO,
 		.bit_depth	= 8,
-		.align		= 32,
+		.opt_align	= 32,
+		.min_align	= 16,
 		.plane_factor	= { P3(1.0) },
 		.num_planes	= 1,
 		.colorspace_mask    = V4L2_COLORSPACE_MASK_RAW,
diff --git a/drivers/media/platform/raspberrypi/rp1_cfe/Kconfig b/drivers/media/platform/raspberrypi/rp1_cfe/Kconfig
new file mode 100644
index 000000000000..8cb1255319fb
--- /dev/null
+++ b/drivers/media/platform/raspberrypi/rp1_cfe/Kconfig
@@ -0,0 +1,14 @@
+# RP1 V4L2 camera support
+
+config VIDEO_RP1_CFE
+	tristate "RP1 Camera Frond End (CFE) video capture driver"
+	depends on VIDEO_DEV
+	select VIDEO_V4L2_SUBDEV_API
+	select MEDIA_CONTROLLER
+	select VIDEOBUF2_DMA_CONTIG
+	select V4L2_FWNODE
+	help
+	  Say Y here to enable support for the RP1 Camera Front End.
+
+	  To compile this driver as a module, choose M here. The module will be
+	  called rp1-cfe.
diff --git a/drivers/media/platform/raspberrypi/rp1_cfe/Makefile b/drivers/media/platform/raspberrypi/rp1_cfe/Makefile
new file mode 100644
index 000000000000..9709d6f603e9
--- /dev/null
+++ b/drivers/media/platform/raspberrypi/rp1_cfe/Makefile
@@ -0,0 +1,6 @@
+# SPDX-License-Identifier: GPL-2.0
+#
+# Makefile for RP1 Camera Front End driver
+#
+rp1-cfe-objs := cfe.o csi2.o pisp_fe.o dphy.o
+obj-$(CONFIG_VIDEO_RP1_CFE) += rp1-cfe.o
